

-- UUAGC 0.9.8 (src/CCO/Picture/AG.ag)
module CCO.Picture.AG where

{-# LINE 2 "src/CCO/Picture/AG/Base.ag" #-}

import CCO.Tree             (ATerm (App), Tree (fromTree, toTree))
import CCO.Tree.Parser      (parseTree, app, arg)
import Control.Applicative  (Applicative ((<*>)), (<$>))
{-# LINE 12 "src/CCO/Picture/AG.hs" #-}

{-# LINE 2 "src/CCO/Picture/AG/Printing.ag" #-}

import CCO.Printing
{-# LINE 17 "src/CCO/Picture/AG.hs" #-}
{-# LINE 29 "src/CCO/Picture/AG/Base.ag" #-}

instance Tree Object where
  fromTree (Line s l)     = App "Line"     [fromTree s, fromTree l]
  fromTree (Makebox d b)  = App "Makebox"  [fromTree d, fromTree b]
  fromTree (Framebox d b) = App "Framebox" [fromTree d, fromTree b]

  toTree = parseTree [ app "Line"     (Line     <$> arg <*> arg)
                     , app "Makebox"  (Makebox  <$> arg <*> arg)
                     , app "Framebox" (Framebox <$> arg <*> arg)
                     ]

instance Tree Command where
  fromTree (Put p o) = App "Put" [fromTree p, fromTree o]
  toTree = parseTree [app "Put" (Put <$> arg <*> arg)]

instance Tree Picture where
  fromTree (Picture d cs) = App "Picture" [fromTree d, fromTree cs]
  toTree = parseTree [app "Picture" (Picture <$> arg <*> arg)]
{-# LINE 37 "src/CCO/Picture/AG.hs" #-}

{-# LINE 34 "src/CCO/Picture/AG/Printing.ag" #-}

ppCall :: Show a => String -> (a, a) -> Doc -> Doc
ppCall cmd args body = singleLine >//< multiLine
  where
    prefix     = text ('\\' : cmd) >|< ppPair args
    singleLine = prefix >|<  braces body
    multiLine  = prefix >|< lbrace >|< text "%" >-< indent 2 body >|< rbrace

ppPair :: Show a => (a, a) -> Doc
ppPair (i, j) = parens (showable i >|< comma >|< showable j)
{-# LINE 50 "src/CCO/Picture/AG.hs" #-}
-- Command -----------------------------------------------------
data Command  = Put ((Double, Double)) (Object) 
-- cata
sem_Command :: Command  ->
               T_Command 
sem_Command (Put _pos _obj )  =
    (sem_Command_Put _pos (sem_Object _obj ) )
-- semantic domain
type T_Command  = ( Doc)
data Inh_Command  = Inh_Command {}
data Syn_Command  = Syn_Command {pp_Syn_Command :: Doc}
wrap_Command :: T_Command  ->
                Inh_Command  ->
                Syn_Command 
wrap_Command sem (Inh_Command )  =
    (let ( _lhsOpp) =
             (sem )
     in  (Syn_Command _lhsOpp ))
sem_Command_Put :: ((Double, Double)) ->
                   T_Object  ->
                   T_Command 
sem_Command_Put pos_ obj_  =
    (let _lhsOpp :: Doc
         _objIpp :: Doc
         _lhsOpp =
             {-# LINE 19 "src/CCO/Picture/AG/Printing.ag" #-}
             ppCall "put" pos_ _objIpp
             {-# LINE 78 "src/CCO/Picture/AG.hs" #-}
         ( _objIpp) =
             (obj_ )
     in  ( _lhsOpp))
-- Commands ----------------------------------------------------
type Commands  = [(Command)]
-- cata
sem_Commands :: Commands  ->
                T_Commands 
sem_Commands list  =
    (Prelude.foldr sem_Commands_Cons sem_Commands_Nil (Prelude.map sem_Command list) )
-- semantic domain
type T_Commands  = ( Doc)
data Inh_Commands  = Inh_Commands {}
data Syn_Commands  = Syn_Commands {pp_Syn_Commands :: Doc}
wrap_Commands :: T_Commands  ->
                 Inh_Commands  ->
                 Syn_Commands 
wrap_Commands sem (Inh_Commands )  =
    (let ( _lhsOpp) =
             (sem )
     in  (Syn_Commands _lhsOpp ))
sem_Commands_Cons :: T_Command  ->
                     T_Commands  ->
                     T_Commands 
sem_Commands_Cons hd_ tl_  =
    (let _lhsOpp :: Doc
         _hdIpp :: Doc
         _tlIpp :: Doc
         _lhsOpp =
             {-# LINE 23 "src/CCO/Picture/AG/Printing.ag" #-}
             _hdIpp >-< _tlIpp
             {-# LINE 110 "src/CCO/Picture/AG.hs" #-}
         ( _hdIpp) =
             (hd_ )
         ( _tlIpp) =
             (tl_ )
     in  ( _lhsOpp))
sem_Commands_Nil :: T_Commands 
sem_Commands_Nil  =
    (let _lhsOpp :: Doc
         _lhsOpp =
             {-# LINE 22 "src/CCO/Picture/AG/Printing.ag" #-}
             empty
             {-# LINE 122 "src/CCO/Picture/AG.hs" #-}
     in  ( _lhsOpp))
-- Object ------------------------------------------------------
data Object  = Framebox ((Double, Double)) (String) 
             | Line ((Int, Int)) (Double) 
             | Makebox ((Double, Double)) (String) 
-- cata
sem_Object :: Object  ->
              T_Object 
sem_Object (Framebox _dim _body )  =
    (sem_Object_Framebox _dim _body )
sem_Object (Line _slope _len )  =
    (sem_Object_Line _slope _len )
sem_Object (Makebox _dim _body )  =
    (sem_Object_Makebox _dim _body )
-- semantic domain
type T_Object  = ( Doc)
data Inh_Object  = Inh_Object {}
data Syn_Object  = Syn_Object {pp_Syn_Object :: Doc}
wrap_Object :: T_Object  ->
               Inh_Object  ->
               Syn_Object 
wrap_Object sem (Inh_Object )  =
    (let ( _lhsOpp) =
             (sem )
     in  (Syn_Object _lhsOpp ))
sem_Object_Framebox :: ((Double, Double)) ->
                       String ->
                       T_Object 
sem_Object_Framebox dim_ body_  =
    (let _lhsOpp :: Doc
         _lhsOpp =
             {-# LINE 16 "src/CCO/Picture/AG/Printing.ag" #-}
             ppCall "framebox" dim_   (text body_)
             {-# LINE 156 "src/CCO/Picture/AG.hs" #-}
     in  ( _lhsOpp))
sem_Object_Line :: ((Int, Int)) ->
                   Double ->
                   T_Object 
sem_Object_Line slope_ len_  =
    (let _lhsOpp :: Doc
         _lhsOpp =
             {-# LINE 14 "src/CCO/Picture/AG/Printing.ag" #-}
             ppCall "line"     slope_ (showable len_)
             {-# LINE 166 "src/CCO/Picture/AG.hs" #-}
     in  ( _lhsOpp))
sem_Object_Makebox :: ((Double, Double)) ->
                      String ->
                      T_Object 
sem_Object_Makebox dim_ body_  =
    (let _lhsOpp :: Doc
         _lhsOpp =
             {-# LINE 15 "src/CCO/Picture/AG/Printing.ag" #-}
             ppCall "makebox"  dim_   (text body_)
             {-# LINE 176 "src/CCO/Picture/AG.hs" #-}
     in  ( _lhsOpp))
-- Picture -----------------------------------------------------
data Picture  = Picture ((Double, Double)) (Commands) 
-- cata
sem_Picture :: Picture  ->
               T_Picture 
sem_Picture (Picture _dim _cmds )  =
    (sem_Picture_Picture _dim (sem_Commands _cmds ) )
-- semantic domain
type T_Picture  = ( Doc)
data Inh_Picture  = Inh_Picture {}
data Syn_Picture  = Syn_Picture {pp_Syn_Picture :: Doc}
wrap_Picture :: T_Picture  ->
                Inh_Picture  ->
                Syn_Picture 
wrap_Picture sem (Inh_Picture )  =
    (let ( _lhsOpp) =
             (sem )
     in  (Syn_Picture _lhsOpp ))
sem_Picture_Picture :: ((Double, Double)) ->
                       T_Commands  ->
                       T_Picture 
sem_Picture_Picture dim_ cmds_  =
    (let _lhsOpp :: Doc
         _cmdsIpp :: Doc
         _lhsOpp =
             {-# LINE 26 "src/CCO/Picture/AG/Printing.ag" #-}
             text "\\begin{picture}" >|< ppPair dim_ >-<
             indent 2 _cmdsIpp >-<
             text "\\end{picture}"
             {-# LINE 207 "src/CCO/Picture/AG.hs" #-}
         ( _cmdsIpp) =
             (cmds_ )
     in  ( _lhsOpp))