

-- UUAGC 0.9.8 (..\src\DiagramTranslator.ag)
module DiagramTranslator where

{-# LINE 4 "..\\src\\DiagramTranslator.ag" #-}

import CCO.Diag.Base
import CCO.Picture.AG
import CCO.SourcePos
import CCO.Printing
{-# LINE 13 "..\\src\\DiagramTranslator.hs" #-}
{-# LINE 87 "..\\src\\DiagramTranslator.ag" #-}

--------------------------------------------------------------------------------
-- functions for getting the LaTeX-commands for drawing the diagram
--------------------------------------------------------------------------------

getCmdsProgram :: String -> String -> Double -> Double -> Commands
getCmdsProgram name lang x y
  = [ Put (x + 7.5, y + 0) (Line (1, 0) 50)
    , Put (x + 7.5, y + 0) (Line (0, 1) 15)
    , Put (x + 7.5, y + 15) (Line (-1, 2) 7.5)
    , Put (x + 57.5, y + 15) (Line (1, 2) 7.5)
    , Put (x + 57.5, y + 0) (Line (0, 1) 15)
    , Put (x + 0, y + 30) (Line (1, 0) 65)
    , Put (x + 7.5, y + 15) (Makebox (50, 15) name)
    , Put (x + 7.5, y + 0) (Makebox (50, 15) lang)
    ]

getCmdsPlatform :: String -> Double -> Double -> Commands
getCmdsPlatform name x y
  = [ Put (x + 0, y + 15) (Line (5, -3) 25)
    , Put (x + 25, y + 0) (Line (5, 3) 25)
    , Put (x + 0, y + 15) (Line (0, 1) 15)
    , Put (x + 0, y + 30) (Line (1, 0) 50)
    , Put (x + 50, y + 30) (Line (0, -1) 15)
    , Put (x + 0, y + 15) (Makebox (50, 15) name)
    ]

getCmdsInterpreter :: String -> String -> String -> Double -> Double -> Commands
getCmdsInterpreter name lang plat x y
  = [ Put (x + 0, y + 0) (Framebox (50, 30) "")
    , Put (x + 0, y + 20) (Makebox (50, 10) lang)
    , Put (x + 0, y + 10) (Makebox (50, 10) name)
    , Put (x + 0, y + 0) (Makebox (50, 10) plat)
    ]

getCmdsCompiler :: String -> String -> String -> String -> Double -> Double -> Commands
getCmdsCompiler name lang1 lang2 plat x y
  = [ Put (x + 50, y + 0) (Line (0, 1) 20)
    , Put (x + 50, y + 20) (Line (-1, 0) 50)
    , Put (x + 0, y + 20) (Line (0, 1) 10)
    , Put (x + 0, y + 30) (Line (1, 0) 150)
    , Put (x + 150, y + 30) (Line (0, -1) 10)
    , Put (x + 150, y + 20) (Line (-1, 0) 50)
    , Put (x + 100, y + 20) (Line (0, -1) 20)
    , Put (x + 100, y + 0) (Line (-1, 0) 50)
    , Put (x + 0, y + 20) (Makebox (50, 10) lang1)
    , Put (x + 50, y + 20) (Makebox (50, 10) "$\\longrightarrow$")
    , Put (x + 100, y + 20) (Makebox (50, 10) lang2)
    , Put (x + 50, y + 10) (Makebox (50, 10) name)
    , Put (x + 50, y + 0) (Makebox (50, 10) plat)
    ]
{-# LINE 66 "..\\src\\DiagramTranslator.hs" #-}
-- Diag --------------------------------------------------------
-- cata
sem_Diag :: Diag  ->
            T_Diag 
sem_Diag (Diag _pos _d )  =
    (sem_Diag_Diag _pos (sem_Diag_ _d ) )
-- semantic domain
type T_Diag  = ( String ) ->
               ( Double ) ->
               ( Double ) ->
               ( Double ) ->
               ( ( Commands ),( Commands ),( String ),( Double ),( Double ),( Double ),( Double ))
data Inh_Diag  = Inh_Diag {compLang_Inh_Diag ::  String ,compX_Inh_Diag ::  Double ,x_Inh_Diag ::  Double ,y_Inh_Diag ::  Double }
data Syn_Diag  = Syn_Diag {cmds_Syn_Diag ::  Commands ,compCmds_Syn_Diag ::  Commands ,compLang_Syn_Diag ::  String ,height_Syn_Diag ::  Double ,marginX_Syn_Diag ::  Double ,marginY_Syn_Diag ::  Double ,width_Syn_Diag ::  Double }
wrap_Diag :: T_Diag  ->
             Inh_Diag  ->
             Syn_Diag 
wrap_Diag sem (Inh_Diag _lhsIcompLang _lhsIcompX _lhsIx _lhsIy )  =
    (let ( _lhsOcmds,_lhsOcompCmds,_lhsOcompLang,_lhsOheight,_lhsOmarginX,_lhsOmarginY,_lhsOwidth) =
             (sem _lhsIcompLang _lhsIcompX _lhsIx _lhsIy )
     in  (Syn_Diag _lhsOcmds _lhsOcompCmds _lhsOcompLang _lhsOheight _lhsOmarginX _lhsOmarginY _lhsOwidth ))
sem_Diag_Diag :: SourcePos ->
                 T_Diag_  ->
                 T_Diag 
sem_Diag_Diag pos_ d_  =
    (\ _lhsIcompLang
       _lhsIcompX
       _lhsIx
       _lhsIy ->
         (let _lhsOcmds :: ( Commands )
              _lhsOcompCmds :: ( Commands )
              _lhsOcompLang :: ( String )
              _lhsOheight :: ( Double )
              _lhsOmarginX :: ( Double )
              _lhsOmarginY :: ( Double )
              _lhsOwidth :: ( Double )
              _dOcompLang :: ( String )
              _dOcompX :: ( Double )
              _dOx :: ( Double )
              _dOy :: ( Double )
              _dIcmds :: ( Commands )
              _dIcompCmds :: ( Commands )
              _dIcompLang :: ( String )
              _dIheight :: ( Double )
              _dImarginX :: ( Double )
              _dImarginY :: ( Double )
              _dIwidth :: ( Double )
              _lhsOcmds =
                  {-# LINE 37 "..\\src\\DiagramTranslator.ag" #-}
                  _dIcmds
                  {-# LINE 117 "..\\src\\DiagramTranslator.hs" #-}
              _lhsOcompCmds =
                  {-# LINE 42 "..\\src\\DiagramTranslator.ag" #-}
                  _dIcompCmds
                  {-# LINE 121 "..\\src\\DiagramTranslator.hs" #-}
              _lhsOcompLang =
                  {-# LINE 41 "..\\src\\DiagramTranslator.ag" #-}
                  _dIcompLang
                  {-# LINE 125 "..\\src\\DiagramTranslator.hs" #-}
              _lhsOheight =
                  {-# LINE 32 "..\\src\\DiagramTranslator.ag" #-}
                  _dIheight
                  {-# LINE 129 "..\\src\\DiagramTranslator.hs" #-}
              _lhsOmarginX =
                  {-# LINE 34 "..\\src\\DiagramTranslator.ag" #-}
                  _dImarginX
                  {-# LINE 133 "..\\src\\DiagramTranslator.hs" #-}
              _lhsOmarginY =
                  {-# LINE 35 "..\\src\\DiagramTranslator.ag" #-}
                  _dImarginY
                  {-# LINE 137 "..\\src\\DiagramTranslator.hs" #-}
              _lhsOwidth =
                  {-# LINE 31 "..\\src\\DiagramTranslator.ag" #-}
                  _dIwidth
                  {-# LINE 141 "..\\src\\DiagramTranslator.hs" #-}
              _dOcompLang =
                  {-# LINE 40 "..\\src\\DiagramTranslator.ag" #-}
                  _lhsIcompLang
                  {-# LINE 145 "..\\src\\DiagramTranslator.hs" #-}
              _dOcompX =
                  {-# LINE 39 "..\\src\\DiagramTranslator.ag" #-}
                  _lhsIcompX
                  {-# LINE 149 "..\\src\\DiagramTranslator.hs" #-}
              _dOx =
                  {-# LINE 28 "..\\src\\DiagramTranslator.ag" #-}
                  _lhsIx
                  {-# LINE 153 "..\\src\\DiagramTranslator.hs" #-}
              _dOy =
                  {-# LINE 29 "..\\src\\DiagramTranslator.ag" #-}
                  _lhsIy
                  {-# LINE 157 "..\\src\\DiagramTranslator.hs" #-}
              ( _dIcmds,_dIcompCmds,_dIcompLang,_dIheight,_dImarginX,_dImarginY,_dIwidth) =
                  (d_ _dOcompLang _dOcompX _dOx _dOy )
          in  ( _lhsOcmds,_lhsOcompCmds,_lhsOcompLang,_lhsOheight,_lhsOmarginX,_lhsOmarginY,_lhsOwidth)))
-- Diag_ -------------------------------------------------------
-- cata
sem_Diag_ :: Diag_  ->
             T_Diag_ 
sem_Diag_ (Compile _d1 _d2 )  =
    (sem_Diag__Compile (sem_Diag _d1 ) (sem_Diag _d2 ) )
sem_Diag_ (Compiler _c _l1 _l2 _m )  =
    (sem_Diag__Compiler _c _l1 _l2 _m )
sem_Diag_ (Execute _d1 _d2 )  =
    (sem_Diag__Execute (sem_Diag _d1 ) (sem_Diag _d2 ) )
sem_Diag_ (Interpreter _i _l _m )  =
    (sem_Diag__Interpreter _i _l _m )
sem_Diag_ (Platform _m )  =
    (sem_Diag__Platform _m )
sem_Diag_ (Program _p _l )  =
    (sem_Diag__Program _p _l )
-- semantic domain
type T_Diag_  = ( String ) ->
                ( Double ) ->
                ( Double ) ->
                ( Double ) ->
                ( ( Commands ),( Commands ),( String ),( Double ),( Double ),( Double ),( Double ))
data Inh_Diag_  = Inh_Diag_ {compLang_Inh_Diag_ ::  String ,compX_Inh_Diag_ ::  Double ,x_Inh_Diag_ ::  Double ,y_Inh_Diag_ ::  Double }
data Syn_Diag_  = Syn_Diag_ {cmds_Syn_Diag_ ::  Commands ,compCmds_Syn_Diag_ ::  Commands ,compLang_Syn_Diag_ ::  String ,height_Syn_Diag_ ::  Double ,marginX_Syn_Diag_ ::  Double ,marginY_Syn_Diag_ ::  Double ,width_Syn_Diag_ ::  Double }
wrap_Diag_ :: T_Diag_  ->
              Inh_Diag_  ->
              Syn_Diag_ 
wrap_Diag_ sem (Inh_Diag_ _lhsIcompLang _lhsIcompX _lhsIx _lhsIy )  =
    (let ( _lhsOcmds,_lhsOcompCmds,_lhsOcompLang,_lhsOheight,_lhsOmarginX,_lhsOmarginY,_lhsOwidth) =
             (sem _lhsIcompLang _lhsIcompX _lhsIx _lhsIy )
     in  (Syn_Diag_ _lhsOcmds _lhsOcompCmds _lhsOcompLang _lhsOheight _lhsOmarginX _lhsOmarginY _lhsOwidth ))
sem_Diag__Compile :: T_Diag  ->
                     T_Diag  ->
                     T_Diag_ 
sem_Diag__Compile d1_ d2_  =
    (\ _lhsIcompLang
       _lhsIcompX
       _lhsIx
       _lhsIy ->
         (let _d2Ox :: ( Double )
              _d1Oy :: ( Double )
              _d1OcompX :: ( Double )
              _d1OcompLang :: ( String )
              _lhsOwidth :: ( Double )
              _lhsOheight :: ( Double )
              _lhsOmarginX :: ( Double )
              _lhsOmarginY :: ( Double )
              _lhsOcmds :: ( Commands )
              _lhsOcompCmds :: ( Commands )
              _lhsOcompLang :: ( String )
              _d1Ox :: ( Double )
              _d2OcompLang :: ( String )
              _d2OcompX :: ( Double )
              _d2Oy :: ( Double )
              _d1Icmds :: ( Commands )
              _d1IcompCmds :: ( Commands )
              _d1IcompLang :: ( String )
              _d1Iheight :: ( Double )
              _d1ImarginX :: ( Double )
              _d1ImarginY :: ( Double )
              _d1Iwidth :: ( Double )
              _d2Icmds :: ( Commands )
              _d2IcompCmds :: ( Commands )
              _d2IcompLang :: ( String )
              _d2Iheight :: ( Double )
              _d2ImarginX :: ( Double )
              _d2ImarginY :: ( Double )
              _d2Iwidth :: ( Double )
              _d2Ox =
                  {-# LINE 76 "..\\src\\DiagramTranslator.ag" #-}
                  _lhsIx + _d1Iwidth - _d1ImarginX
                  {-# LINE 232 "..\\src\\DiagramTranslator.hs" #-}
              _d1Oy =
                  {-# LINE 77 "..\\src\\DiagramTranslator.ag" #-}
                  _lhsIy + _d2Iheight - 10
                  {-# LINE 236 "..\\src\\DiagramTranslator.hs" #-}
              _d1OcompX =
                  {-# LINE 78 "..\\src\\DiagramTranslator.ag" #-}
                  _d1Iwidth - _d1ImarginX + _d2Iwidth  - _d1ImarginX
                  {-# LINE 240 "..\\src\\DiagramTranslator.hs" #-}
              _d1OcompLang =
                  {-# LINE 79 "..\\src\\DiagramTranslator.ag" #-}
                  _d2IcompLang
                  {-# LINE 244 "..\\src\\DiagramTranslator.hs" #-}
              _lhsOwidth =
                  {-# LINE 80 "..\\src\\DiagramTranslator.ag" #-}
                  (_d1Iwidth - _d1ImarginX) * 2 + _d2Iwidth
                  {-# LINE 248 "..\\src\\DiagramTranslator.hs" #-}
              _lhsOheight =
                  {-# LINE 81 "..\\src\\DiagramTranslator.ag" #-}
                  _d1Iheight + _d2Iheight - 10
                  {-# LINE 252 "..\\src\\DiagramTranslator.hs" #-}
              _lhsOmarginX =
                  {-# LINE 82 "..\\src\\DiagramTranslator.ag" #-}
                  _d1Iwidth - _d1ImarginX + _d2Iwidth
                  {-# LINE 256 "..\\src\\DiagramTranslator.hs" #-}
              _lhsOmarginY =
                  {-# LINE 83 "..\\src\\DiagramTranslator.ag" #-}
                  _d2Iheight - 10
                  {-# LINE 260 "..\\src\\DiagramTranslator.hs" #-}
              _lhsOcmds =
                  {-# LINE 84 "..\\src\\DiagramTranslator.ag" #-}
                  _d1Icmds
                  ++ _d2Icmds
                  ++ _d1IcompCmds
                  {-# LINE 266 "..\\src\\DiagramTranslator.hs" #-}
              _lhsOcompCmds =
                  {-# LINE 42 "..\\src\\DiagramTranslator.ag" #-}
                  _d1IcompCmds  ++  _d2IcompCmds
                  {-# LINE 270 "..\\src\\DiagramTranslator.hs" #-}
              _lhsOcompLang =
                  {-# LINE 41 "..\\src\\DiagramTranslator.ag" #-}
                  _d2IcompLang
                  {-# LINE 274 "..\\src\\DiagramTranslator.hs" #-}
              _d1Ox =
                  {-# LINE 28 "..\\src\\DiagramTranslator.ag" #-}
                  _lhsIx
                  {-# LINE 278 "..\\src\\DiagramTranslator.hs" #-}
              _d2OcompLang =
                  {-# LINE 40 "..\\src\\DiagramTranslator.ag" #-}
                  _d1IcompLang
                  {-# LINE 282 "..\\src\\DiagramTranslator.hs" #-}
              _d2OcompX =
                  {-# LINE 39 "..\\src\\DiagramTranslator.ag" #-}
                  _lhsIcompX
                  {-# LINE 286 "..\\src\\DiagramTranslator.hs" #-}
              _d2Oy =
                  {-# LINE 29 "..\\src\\DiagramTranslator.ag" #-}
                  _lhsIy
                  {-# LINE 290 "..\\src\\DiagramTranslator.hs" #-}
              ( _d1Icmds,_d1IcompCmds,_d1IcompLang,_d1Iheight,_d1ImarginX,_d1ImarginY,_d1Iwidth) =
                  (d1_ _d1OcompLang _d1OcompX _d1Ox _d1Oy )
              ( _d2Icmds,_d2IcompCmds,_d2IcompLang,_d2Iheight,_d2ImarginX,_d2ImarginY,_d2Iwidth) =
                  (d2_ _d2OcompLang _d2OcompX _d2Ox _d2Oy )
          in  ( _lhsOcmds,_lhsOcompCmds,_lhsOcompLang,_lhsOheight,_lhsOmarginX,_lhsOmarginY,_lhsOwidth)))
sem_Diag__Compiler :: Ident ->
                      Ident ->
                      Ident ->
                      Ident ->
                      T_Diag_ 
sem_Diag__Compiler c_ l1_ l2_ m_  =
    (\ _lhsIcompLang
       _lhsIcompX
       _lhsIx
       _lhsIy ->
         (let _lhsOwidth :: ( Double )
              _lhsOheight :: ( Double )
              _lhsOmarginX :: ( Double )
              _lhsOmarginY :: ( Double )
              _lhsOcmds :: ( Commands )
              _lhsOcompCmds :: ( Commands )
              _lhsOcompLang :: ( String )
              _lhsOwidth =
                  {-# LINE 62 "..\\src\\DiagramTranslator.ag" #-}
                  150
                  {-# LINE 316 "..\\src\\DiagramTranslator.hs" #-}
              _lhsOheight =
                  {-# LINE 63 "..\\src\\DiagramTranslator.ag" #-}
                  30
                  {-# LINE 320 "..\\src\\DiagramTranslator.hs" #-}
              _lhsOmarginX =
                  {-# LINE 64 "..\\src\\DiagramTranslator.ag" #-}
                  50
                  {-# LINE 324 "..\\src\\DiagramTranslator.hs" #-}
              _lhsOmarginY =
                  {-# LINE 65 "..\\src\\DiagramTranslator.ag" #-}
                  0
                  {-# LINE 328 "..\\src\\DiagramTranslator.hs" #-}
              _lhsOcmds =
                  {-# LINE 66 "..\\src\\DiagramTranslator.ag" #-}
                  getCmdsCompiler c_ l1_ l2_ m_ _lhsIx _lhsIy
                  {-# LINE 332 "..\\src\\DiagramTranslator.hs" #-}
              _lhsOcompCmds =
                  {-# LINE 67 "..\\src\\DiagramTranslator.ag" #-}
                  getCmdsCompiler c_ l1_ l2_ _lhsIcompLang _lhsIcompX _lhsIy
                  {-# LINE 336 "..\\src\\DiagramTranslator.hs" #-}
              _lhsOcompLang =
                  {-# LINE 68 "..\\src\\DiagramTranslator.ag" #-}
                  l2_
                  {-# LINE 340 "..\\src\\DiagramTranslator.hs" #-}
          in  ( _lhsOcmds,_lhsOcompCmds,_lhsOcompLang,_lhsOheight,_lhsOmarginX,_lhsOmarginY,_lhsOwidth)))
sem_Diag__Execute :: T_Diag  ->
                     T_Diag  ->
                     T_Diag_ 
sem_Diag__Execute d1_ d2_  =
    (\ _lhsIcompLang
       _lhsIcompX
       _lhsIx
       _lhsIy ->
         (let _d2Ox :: ( Double )
              _d1Oy :: ( Double )
              _lhsOwidth :: ( Double )
              _lhsOheight :: ( Double )
              _lhsOmarginX :: ( Double )
              _lhsOmarginY :: ( Double )
              _lhsOcmds :: ( Commands )
              _lhsOcompCmds :: ( Commands )
              _lhsOcompLang :: ( String )
              _d1OcompLang :: ( String )
              _d1OcompX :: ( Double )
              _d1Ox :: ( Double )
              _d2OcompLang :: ( String )
              _d2OcompX :: ( Double )
              _d2Oy :: ( Double )
              _d1Icmds :: ( Commands )
              _d1IcompCmds :: ( Commands )
              _d1IcompLang :: ( String )
              _d1Iheight :: ( Double )
              _d1ImarginX :: ( Double )
              _d1ImarginY :: ( Double )
              _d1Iwidth :: ( Double )
              _d2Icmds :: ( Commands )
              _d2IcompCmds :: ( Commands )
              _d2IcompLang :: ( String )
              _d2Iheight :: ( Double )
              _d2ImarginX :: ( Double )
              _d2ImarginY :: ( Double )
              _d2Iwidth :: ( Double )
              _d2Ox =
                  {-# LINE 69 "..\\src\\DiagramTranslator.ag" #-}
                  _lhsIx + _d1ImarginX
                  {-# LINE 382 "..\\src\\DiagramTranslator.hs" #-}
              _d1Oy =
                  {-# LINE 70 "..\\src\\DiagramTranslator.ag" #-}
                  _lhsIy + _d2Iheight - _d1ImarginY
                  {-# LINE 386 "..\\src\\DiagramTranslator.hs" #-}
              _lhsOwidth =
                  {-# LINE 71 "..\\src\\DiagramTranslator.ag" #-}
                  _d1Iwidth `max` _d2Iwidth
                  {-# LINE 390 "..\\src\\DiagramTranslator.hs" #-}
              _lhsOheight =
                  {-# LINE 72 "..\\src\\DiagramTranslator.ag" #-}
                  _d1Iheight + _d2Iheight - _d1ImarginY
                  {-# LINE 394 "..\\src\\DiagramTranslator.hs" #-}
              _lhsOmarginX =
                  {-# LINE 73 "..\\src\\DiagramTranslator.ag" #-}
                  _d1ImarginX
                  {-# LINE 398 "..\\src\\DiagramTranslator.hs" #-}
              _lhsOmarginY =
                  {-# LINE 74 "..\\src\\DiagramTranslator.ag" #-}
                  _d1ImarginY
                  {-# LINE 402 "..\\src\\DiagramTranslator.hs" #-}
              _lhsOcmds =
                  {-# LINE 75 "..\\src\\DiagramTranslator.ag" #-}
                  _d1Icmds ++ _d2Icmds
                  {-# LINE 406 "..\\src\\DiagramTranslator.hs" #-}
              _lhsOcompCmds =
                  {-# LINE 42 "..\\src\\DiagramTranslator.ag" #-}
                  _d1IcompCmds  ++  _d2IcompCmds
                  {-# LINE 410 "..\\src\\DiagramTranslator.hs" #-}
              _lhsOcompLang =
                  {-# LINE 41 "..\\src\\DiagramTranslator.ag" #-}
                  _d2IcompLang
                  {-# LINE 414 "..\\src\\DiagramTranslator.hs" #-}
              _d1OcompLang =
                  {-# LINE 40 "..\\src\\DiagramTranslator.ag" #-}
                  _lhsIcompLang
                  {-# LINE 418 "..\\src\\DiagramTranslator.hs" #-}
              _d1OcompX =
                  {-# LINE 39 "..\\src\\DiagramTranslator.ag" #-}
                  _lhsIcompX
                  {-# LINE 422 "..\\src\\DiagramTranslator.hs" #-}
              _d1Ox =
                  {-# LINE 28 "..\\src\\DiagramTranslator.ag" #-}
                  _lhsIx
                  {-# LINE 426 "..\\src\\DiagramTranslator.hs" #-}
              _d2OcompLang =
                  {-# LINE 40 "..\\src\\DiagramTranslator.ag" #-}
                  _d1IcompLang
                  {-# LINE 430 "..\\src\\DiagramTranslator.hs" #-}
              _d2OcompX =
                  {-# LINE 39 "..\\src\\DiagramTranslator.ag" #-}
                  _lhsIcompX
                  {-# LINE 434 "..\\src\\DiagramTranslator.hs" #-}
              _d2Oy =
                  {-# LINE 29 "..\\src\\DiagramTranslator.ag" #-}
                  _lhsIy
                  {-# LINE 438 "..\\src\\DiagramTranslator.hs" #-}
              ( _d1Icmds,_d1IcompCmds,_d1IcompLang,_d1Iheight,_d1ImarginX,_d1ImarginY,_d1Iwidth) =
                  (d1_ _d1OcompLang _d1OcompX _d1Ox _d1Oy )
              ( _d2Icmds,_d2IcompCmds,_d2IcompLang,_d2Iheight,_d2ImarginX,_d2ImarginY,_d2Iwidth) =
                  (d2_ _d2OcompLang _d2OcompX _d2Ox _d2Oy )
          in  ( _lhsOcmds,_lhsOcompCmds,_lhsOcompLang,_lhsOheight,_lhsOmarginX,_lhsOmarginY,_lhsOwidth)))
sem_Diag__Interpreter :: Ident ->
                         Ident ->
                         Ident ->
                         T_Diag_ 
sem_Diag__Interpreter i_ l_ m_  =
    (\ _lhsIcompLang
       _lhsIcompX
       _lhsIx
       _lhsIy ->
         (let _lhsOwidth :: ( Double )
              _lhsOheight :: ( Double )
              _lhsOmarginX :: ( Double )
              _lhsOmarginY :: ( Double )
              _lhsOcmds :: ( Commands )
              _lhsOcompCmds :: ( Commands )
              _lhsOcompLang :: ( String )
              _lhsOwidth =
                  {-# LINE 56 "..\\src\\DiagramTranslator.ag" #-}
                  50
                  {-# LINE 463 "..\\src\\DiagramTranslator.hs" #-}
              _lhsOheight =
                  {-# LINE 57 "..\\src\\DiagramTranslator.ag" #-}
                  30
                  {-# LINE 467 "..\\src\\DiagramTranslator.hs" #-}
              _lhsOmarginX =
                  {-# LINE 58 "..\\src\\DiagramTranslator.ag" #-}
                  0
                  {-# LINE 471 "..\\src\\DiagramTranslator.hs" #-}
              _lhsOmarginY =
                  {-# LINE 59 "..\\src\\DiagramTranslator.ag" #-}
                  0
                  {-# LINE 475 "..\\src\\DiagramTranslator.hs" #-}
              _lhsOcmds =
                  {-# LINE 60 "..\\src\\DiagramTranslator.ag" #-}
                  getCmdsInterpreter i_ l_ m_ _lhsIx _lhsIy
                  {-# LINE 479 "..\\src\\DiagramTranslator.hs" #-}
              _lhsOcompCmds =
                  {-# LINE 61 "..\\src\\DiagramTranslator.ag" #-}
                  getCmdsInterpreter i_ l_ _lhsIcompLang _lhsIcompX _lhsIy
                  {-# LINE 483 "..\\src\\DiagramTranslator.hs" #-}
              _lhsOcompLang =
                  {-# LINE 41 "..\\src\\DiagramTranslator.ag" #-}
                  _lhsIcompLang
                  {-# LINE 487 "..\\src\\DiagramTranslator.hs" #-}
          in  ( _lhsOcmds,_lhsOcompCmds,_lhsOcompLang,_lhsOheight,_lhsOmarginX,_lhsOmarginY,_lhsOwidth)))
sem_Diag__Platform :: Ident ->
                      T_Diag_ 
sem_Diag__Platform m_  =
    (\ _lhsIcompLang
       _lhsIcompX
       _lhsIx
       _lhsIy ->
         (let _lhsOwidth :: ( Double )
              _lhsOheight :: ( Double )
              _lhsOmarginX :: ( Double )
              _lhsOmarginY :: ( Double )
              _lhsOcmds :: ( Commands )
              _lhsOcompCmds :: ( Commands )
              _lhsOcompLang :: ( String )
              _lhsOwidth =
                  {-# LINE 51 "..\\src\\DiagramTranslator.ag" #-}
                  50
                  {-# LINE 506 "..\\src\\DiagramTranslator.hs" #-}
              _lhsOheight =
                  {-# LINE 52 "..\\src\\DiagramTranslator.ag" #-}
                  30
                  {-# LINE 510 "..\\src\\DiagramTranslator.hs" #-}
              _lhsOmarginX =
                  {-# LINE 53 "..\\src\\DiagramTranslator.ag" #-}
                  0
                  {-# LINE 514 "..\\src\\DiagramTranslator.hs" #-}
              _lhsOmarginY =
                  {-# LINE 54 "..\\src\\DiagramTranslator.ag" #-}
                  0
                  {-# LINE 518 "..\\src\\DiagramTranslator.hs" #-}
              _lhsOcmds =
                  {-# LINE 55 "..\\src\\DiagramTranslator.ag" #-}
                  getCmdsPlatform m_ _lhsIx _lhsIy
                  {-# LINE 522 "..\\src\\DiagramTranslator.hs" #-}
              _lhsOcompCmds =
                  {-# LINE 42 "..\\src\\DiagramTranslator.ag" #-}
                  []
                  {-# LINE 526 "..\\src\\DiagramTranslator.hs" #-}
              _lhsOcompLang =
                  {-# LINE 41 "..\\src\\DiagramTranslator.ag" #-}
                  _lhsIcompLang
                  {-# LINE 530 "..\\src\\DiagramTranslator.hs" #-}
          in  ( _lhsOcmds,_lhsOcompCmds,_lhsOcompLang,_lhsOheight,_lhsOmarginX,_lhsOmarginY,_lhsOwidth)))
sem_Diag__Program :: Ident ->
                     Ident ->
                     T_Diag_ 
sem_Diag__Program p_ l_  =
    (\ _lhsIcompLang
       _lhsIcompX
       _lhsIx
       _lhsIy ->
         (let _lhsOwidth :: ( Double )
              _lhsOheight :: ( Double )
              _lhsOmarginX :: ( Double )
              _lhsOmarginY :: ( Double )
              _lhsOcmds :: ( Commands )
              _lhsOcompCmds :: ( Commands )
              _lhsOcompLang :: ( String )
              _lhsOwidth =
                  {-# LINE 45 "..\\src\\DiagramTranslator.ag" #-}
                  65
                  {-# LINE 550 "..\\src\\DiagramTranslator.hs" #-}
              _lhsOheight =
                  {-# LINE 46 "..\\src\\DiagramTranslator.ag" #-}
                  30
                  {-# LINE 554 "..\\src\\DiagramTranslator.hs" #-}
              _lhsOmarginX =
                  {-# LINE 47 "..\\src\\DiagramTranslator.ag" #-}
                  7.5
                  {-# LINE 558 "..\\src\\DiagramTranslator.hs" #-}
              _lhsOmarginY =
                  {-# LINE 48 "..\\src\\DiagramTranslator.ag" #-}
                  0
                  {-# LINE 562 "..\\src\\DiagramTranslator.hs" #-}
              _lhsOcmds =
                  {-# LINE 49 "..\\src\\DiagramTranslator.ag" #-}
                  getCmdsProgram p_ l_ _lhsIx _lhsIy
                  {-# LINE 566 "..\\src\\DiagramTranslator.hs" #-}
              _lhsOcompCmds =
                  {-# LINE 50 "..\\src\\DiagramTranslator.ag" #-}
                  getCmdsProgram p_ _lhsIcompLang _lhsIcompX _lhsIy
                  {-# LINE 570 "..\\src\\DiagramTranslator.hs" #-}
              _lhsOcompLang =
                  {-# LINE 41 "..\\src\\DiagramTranslator.ag" #-}
                  _lhsIcompLang
                  {-# LINE 574 "..\\src\\DiagramTranslator.hs" #-}
          in  ( _lhsOcmds,_lhsOcompCmds,_lhsOcompLang,_lhsOheight,_lhsOmarginX,_lhsOmarginY,_lhsOwidth)))